vm_exec.h File Reference

Go to the source code of this file.

## Macros

#define | USAGE_ANALYSIS_INSN(insn) /* none */
#define | USAGE_ANALYSIS_OPERAND(insn, n, op) /* none */
#define | USAGE_ANALYSIS_REGISTER(reg, s) /* none */
#define | PREFETCH(pc)
#define | debugs
#define | DEBUG_ENTER_INSN(insn)
#define | DEBUG_END_INSN()
#define | throwdebug if(0)printf
#define | INSN_ENTRY(insn) case BIN(insn):
#define | END_INSN(insn)
#define | INSN_DISPATCH()
#define | END_INSNS_DISPATCH()
#define | NEXT_INSN() goto first
#define | VM_SP_CNT(th, sp) ((sp) - (th)->stack)
#define | THROW_EXCEPTION(exc) return (VALUE)(exc)
#define | SCREG(r) (reg_##r)

## Typedefs

typedef long | OFFSET
typedef unsigned long | lindex_t
typedef unsigned long | dindex_t
typedef rb_num_t | GENTRY
typedef rb_iseq_t * | ISEQ

## Macro Definition Documentation

#define DEBUG_END_INSN | ( |  | ) |

Definition at line 56 of file vm_exec.h.

#define DEBUG_ENTER_INSN | ( |  | insn | ) |

Definition at line 55 of file vm_exec.h.

#define debugs

Definition at line 54 of file vm_exec.h.

#define END_INSN | ( |  | insn | ) |

Value:
DEBUG_END_INSN(); \
break;

Definition at line 151 of file vm_exec.h.

#define END_INSNS_DISPATCH | ( |  | ) |

Value:
default: \
SDR(); \
rb_bug("unknown insn: %ld", GET_CURRENT_INSN()); \
} /* end of switch */ \
} /* end of while loop */ \

Definition at line 160 of file vm_exec.h.

Referenced by vm_exec_core().

#define INSN_DISPATCH | ( |  | ) |

Value:
while(1){ \
switch(GET_CURRENT_INSN()){

Definition at line 156 of file vm_exec.h.

Referenced by vm_exec_core().

#define INSN_ENTRY | ( |  | insn | ) | case BIN(insn):

Definition at line 148 of file vm_exec.h.

#define NEXT_INSN | ( |  | ) | goto first

Definition at line 167 of file vm_exec.h.

#define PREFETCH | ( |  | pc | ) |

Definition at line 35 of file vm_exec.h.

#define SCREG | ( |  | r | ) | (reg_##r)

Definition at line 182 of file vm_exec.h.

#define THROW_EXCEPTION | ( |  | exc | ) | return (VALUE)(exc)

Definition at line 179 of file vm_exec.h.

#define throwdebug if(0)printf

Definition at line 59 of file vm_exec.h.

#define USAGE_ANALYSIS_INSN | ( |  | insn | ) | /* none */

Definition at line 26 of file vm_exec.h.

#define USAGE_ANALYSIS_OPERAND | ( |  | insn,
|  |  | n,
|  |  | op
| ) |  | /* none */

Definition at line 27 of file vm_exec.h.

#define USAGE_ANALYSIS_REGISTER | ( |  | reg,
|  |  | s
| ) |  | /* none */

Definition at line 28 of file vm_exec.h.

#define VM_SP_CNT | ( |  | th,
|  |  | sp
| ) |  | ((sp) - (th)->stack)

Definition at line 171 of file vm_exec.h.

## Typedef Documentation

typedef unsigned long dindex_t

Definition at line 17 of file vm_exec.h.

typedef rb_num_t GENTRY

Definition at line 18 of file vm_exec.h.

typedef rb_iseq_t* ISEQ

Definition at line 19 of file vm_exec.h.

typedef unsigned long lindex_t

Definition at line 16 of file vm_exec.h.

typedef long OFFSET

Definition at line 15 of file vm_exec.h.